/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_preferences_edit.js,v 1.7 2006/05/16 20:53:54 froebel Exp $
 * ***** END CVS HEADERS ***** */

var wbPrefs = null;

function onLoadPageEdit() {
	wbPrefs = getPreferences();
	document.getElementById('wikipedia.username').value = wbPrefs.getCharPref("username");
	document.getElementById('wikipedia.linkdialog.checkbox').checked = wbPrefs.getBoolPref("linkdialog");
	document.getElementById('wikipedia.selectionlink').value = wbPrefs.getIntPref("selectionlink");
	document.getElementById('wikipedia.activation.kind').value = wbPrefs.getIntPref("activation.kind");
	document.getElementById('wikipedia.activation.condition').value = wbPrefs.getCharPref("activation.condition");
	document.getElementById('wikipedia.icon.size').value = wbPrefs.getIntPref("icon.size");
	document.getElementById('wikipedia.restrictedspecial').checked = wbPrefs.getBoolPref("restrictedspecial");
	document.getElementById('wikipedia.homeonchange').checked = wbPrefs.getBoolPref("homeonchange");
	document.getElementById('wikipedia.history').value = wbPrefs.getIntPref("history.max.count");
	document.getElementById('wikipedia.sitetemplate.displayoptions').value = wbPrefs.getIntPref("sitemenugrouping");
	updateLinkSelection();
}

function onSavePageEdit() {
	wbPrefs.setCharPref("username", document.getElementById('wikipedia.username').value);
	wbPrefs.setBoolPref("linkdialog", document.getElementById('wikipedia.linkdialog.checkbox').checked);
	wbPrefs.setIntPref("selectionlink", document.getElementById('wikipedia.selectionlink').value);
	wbPrefs.setIntPref("activation.kind", document.getElementById('wikipedia.activation.kind').value);
	wbPrefs.setCharPref("activation.condition", document.getElementById('wikipedia.activation.condition').value);
	wbPrefs.setIntPref("icon.size", document.getElementById('wikipedia.icon.size').value);
	wbPrefs.setBoolPref("restrictedspecial", document.getElementById('wikipedia.restrictedspecial').checked);
	wbPrefs.setBoolPref("homeonchange", document.getElementById('wikipedia.homeonchange').checked);
	wbPrefs.setIntPref("history.max.count", document.getElementById('wikipedia.history').value);
	wbPrefs.setIntPref("sitemenugrouping", document.getElementById('wikipedia.sitetemplate.displayoptions').value);
}

function updateLinkSelection() {
	var disabled = !document.getElementById('wikipedia.linkdialog.checkbox').checked;
	document.getElementById('wikipedia-selection-group').disabled = disabled;
	document.getElementById('edit-link-target').disabled = disabled;
	document.getElementById('edit-link-visible').disabled = disabled;
}

function onLoadPageView() {
	updateActivationSettings();
}

function updateActivationSettings() {
	document.getElementById('wikipedia.activation.condition').disabled = !document.getElementById('wikipedia-activation-conditional').selected;
}

function updateToolbarSettings() {
	//	send a obs ping
}