/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_preferences_formats.js,v 1.3 2006/04/15 06:10:47 froebel Exp $
 * ***** END CVS HEADERS ***** */

function onLoadPageFormats() {
	loadFormats();
	document.getElementById('wikipedia.checks.openclose').checked = wbPrefs.getBoolPref("checks.openclose");
	document.getElementById('wikipedia.checks.headers').checked = wbPrefs.getBoolPref("checks.headers");
	document.getElementById('wikipedia.checks.multiplelink').checked = wbPrefs.getBoolPref("checks.multiplelink");
	document.getElementById('wikipedia.signature.selection').value = wbPrefs.getIntPref("signature.selection");
	document.getElementById('wikipedia.signature.text').value = wbPrefs.getCharPref("signature.text");
	updateActivationSettings();
}

function onSavePageFormats() {
	wbPrefs.setBoolPref("checks.openclose", document.getElementById('wikipedia.checks.openclose').checked);
	wbPrefs.setBoolPref("checks.headers", document.getElementById('wikipedia.checks.headers').checked);
	wbPrefs.setBoolPref("checks.multiplelink", document.getElementById('wikipedia.checks.multiplelink').checked);
	wbPrefs.setIntPref("signature.selection", document.getElementById('wikipedia.signature.selection').value);
	wbPrefs.setCharPref("signature.text", document.getElementById('wikipedia.signature.text').value);
}

function updateActivationSettings() {
	document.getElementById('wikipedia.signature.text').disabled = !document.getElementById('wikipedia.signature.user').selected;
}

function addFormatItem(label,text) {
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("label",label);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",text);
	row.appendChild(cell);
	item.appendChild(row);
	document.getElementById('formats').appendChild(item);
}

function addFormat() {
	var ok = [false];
	var params = ["","<format>SELECTION</format>"];
	window.openDialog("chrome://wikipedia/content/wikipedia_format_properties.xul", "&wikipedia.format.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]) {
		var label = params[0];
		var text = params[1];
		addFormatItem(label,text);
	}
	storeFormats();
}

function editFormat() {
	var tree=document.getElementById('tree-formats');
	var item=tree.view.getItemAtIndex(tree.currentIndex);
	var label=item.firstChild.firstChild.getAttribute("label");
	var text=item.firstChild.firstChild.nextSibling.getAttribute("label");
	var ok = [false];
	var params = [label,text];
	window.openDialog("chrome://wikipedia/content/wikipedia_format_properties.xul", "&wikipedia.format.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		label=params[0];
		text=params[1];
		item.firstChild.firstChild.setAttribute("label",label);
		item.firstChild.firstChild.nextSibling.setAttribute("label",text);
	}
	storeFormats();
}

function deleteFormat() {
	var tree=document.getElementById('tree-formats');
	var item=tree.view.getItemAtIndex(tree.currentIndex);
	document.getElementById('formats').removeChild(item);
	enableDelete(false);
	storeFormats();
}

function enableDelete(e) {
	document.getElementById('format-edit').disabled=!e;
	document.getElementById('format-delete').disabled=!e;
}

function storeFormats() {
	var wbPrefs = getPreferences();
	var items=document.getElementById('formats').childNodes;
	for (var i=0;i<items.length;i++) {
		wbPrefs.setCharPref(OPTION_USER_FORMAT+"."+i+".label",encodeURIComponent(items[i].firstChild.firstChild.getAttribute("label")));
		wbPrefs.setCharPref(OPTION_USER_FORMAT+"."+i+".text",encodeURIComponent(items[i].firstChild.firstChild.nextSibling.getAttribute("label")));
	}
	wbPrefs.setIntPref(OPTION_USER_FORMAT+".count",items.length);
}

function loadFormats() {
	var wbPrefs = getPreferences();
	var count=wbPrefs.getIntPref(OPTION_USER_FORMAT+".count");
	for (var i=0;i<count;i++) {
		var label=decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_FORMAT+"."+i+".label"));
		var text=decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_FORMAT+"."+i+".text"));
		addFormatItem(label,text);
	}
}