/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_special.js,v 1.2 2006/04/11 14:27:34 froebel Exp $
 * ***** END CVS HEADERS ***** */

var currentRow = null;
var currentColumn = 0;
var wikipedia = null;

function addCharacter(character, shownLabel) {
	var row = currentRow;
	if ((currentRow == null) || (currentColumn == 10)) {
		var rows = document.getElementById("character_rows");
		row = document.createElement('row');
		rows.appendChild(row);
		currentColumn = 0;
		currentRow = row;
	}
	var label = document.createElement('label');
	label.setAttribute('value',shownLabel);
	label.setAttribute('onclick',"select('"+character+"')");
	row.appendChild(label);
	currentColumn++;
}

function loadCharacterCollection(id) {
	currentRow = null;
	currentColumn = 0;
	var rows = document.getElementById("character_rows");
	while (rows.firstChild != null) {
		rows.removeChild(rows.firstChild);
	}
	var nodelist = getNodes("chrome://wikipedia/content/special_characters.xml","/characters/characterCollection[attribute::id='"+id+"']/character");
	for (var i = 0; i < nodelist.length; i++) {
		var node = nodelist[i];
		var character = node.getAttribute('value');
		var label = node.getAttribute('label');
		if (label == null) {
			label = character;
		}
		addCharacter(character, label);
	}
	getPreferences().setCharPref('specialchars.collection',id);
//	document.getElementById('wikipedia-special').sizeToContent();
}

function loadCharacterCollections() {
	var lastCollection=getPreferences().getCharPref('specialchars.collection');
	var nodelist = getNodes("chrome://wikipedia/content/special_characters.xml","/characters/characterCollection");
	for(var i = 0; i < nodelist.length; i++) {
		var node = nodelist[i];
		var id = node.getAttribute('id');
		var label = node.getAttribute('label');
		var languages = document.getElementById('special-languages');
		var item = document.createElement('menuitem');
		item.setAttribute('label',label);
		item.setAttribute('value',id);
		item.setAttribute('oncommand',"loadCharacterCollection('"+id+"')");
		if ((lastCollection == '' && i == 0) || (lastCollection == id)) {
			loadCharacterCollection(id);
			item.setAttribute('selected','true');
		}
		languages.appendChild(item);
	}
}

function onLoad() {
	var params = window.arguments[1];
	wikipedia = params[1];
	loadCharacterCollections();
}

function select(character) {
	wikipedia.insert(character);
}

function onCancel() {
	var ok = window.arguments[0]; 
	ok[0] = false;
	return true;
}

function charSelected(event) {
	alert(event.target.tagName);
	return true;
}